#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Indicator;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Strategy;
#endregion

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    /// <summary>
    /// Enter the description of your strategy here
    /// </summary>
    [Description("Enter the description of your strategy here")]
    public class ZsBorrar03 : Strategy
    {
        #region Variables
        // Wizard generated variables
        private int periodo = 14; // Default setting for Periodo
		private int barrasStop = 4; // Default setting for Periodo
        // User defined variables (add any user defined variables below)
        #endregion

        /// <summary>
        /// This method is used to configure the strategy and is called once before any strategy method is called.
        /// </summary>
        protected override void Initialize()
        {
            CalculateOnBarClose = true;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			bool flag1 = ( Open[0] 	< SMA( Close, periodo )[0] - StdDev( Close, periodo )[0] );
			bool flag2 = ( Close[0]	< SMA( Close, periodo )[0] - StdDev( Close, periodo )[0] );
			bool flag3 = ( Close[0]	> SMA( Close, periodo )[0] );
			bool flag4 = ( Close[0]	> SMA( Close, periodo )[0] );
			bool flag5 = ( Open[0]  < SMA( Close, periodo )[0] - StdDev( Close, periodo )[0] );
			bool flag6 = ( Close[0]	< SMA( Close, periodo )[0] - StdDev( Close, periodo )[0] );
			
			//Original pero con stop-loss:
			switch ( Position.MarketPosition )
			{
				case MarketPosition.Flat:
				{
					if ( flag1 && flag2 )
					{
						EnterLong( 1, "EntrarLargo" );
						if ( barrasStop > 0 ) 
							SetStopLoss( "EntrarLargo", CalculationMode.Price, MIN( Low, barrasStop )[0], true );
					}
					else if ( flag4 )
					{
						EnterShort( 1, "EntrarCorto" );
						if ( barrasStop > 0 ) 
							SetStopLoss( "EntrarCorto", CalculationMode.Price, MAX( High, barrasStop )[0], true);
					}
					break;
				}
				case MarketPosition.Long:
				{
					if ( flag3 )
						ExitLong( 1, "SalirLargo", "EntrarLargo" );
					break;
				}
				case MarketPosition.Short:
				{
					if ( flag5 && flag6 )
						ExitShort( 1, "SalirCorto", "EntrarCorto" );
					break;
				}
			}
			
//			switch ( Position.MarketPosition )
//			{
//				case MarketPosition.Flat:
//				{
//					if ( flag1 && flag2 )
//						EnterLong( 1, "EntrarLargo" );
//					else if ( flag4 )
//						EnterShort( 1, "EntrarCorto" );
//					break;
//				}
//				case MarketPosition.Long:
//				{
//					if ( flag3 )
//						EnterShort( 1, "EntrarCorto" );
//						//ExitLong( 1, "SalirLargo", "EntrarLargo" );
//					break;
//				}
//				case MarketPosition.Short:
//				{
//					if ( flag5 && flag6 )
//						EnterLong( 1, "EntrarLargo" );
//						//ExitShort( 1, "SalirCorto", "EntrarCorto" );
//					break;
//				}
//			}
			
			
//			//Original:
//			switch ( Position.MarketPosition )
//			{
//				case MarketPosition.Flat:
//				{
//					if ( flag1 && flag2 )
//						EnterLong( 1, "EntrarLargo" );
//					else if ( flag4 )
//						EnterShort( 1, "EntrarCorto" );
//					break;
//				}
//				case MarketPosition.Long:
//				{
//					if ( flag3 )
//						ExitLong( 1, "SalirLargo", "EntrarLargo" );
//					break;
//				}
//				case MarketPosition.Short:
//				{
//					if ( flag5 && flag6 )
//						ExitShort( 1, "SalirCorto", "EntrarCorto" );
//					break;
//				}
//			}
			
        }

        #region Properties
        [Description("Período")]
        [Category("Parameters")]
        public int Periodo
        {
            get { return periodo; }
            set { periodo = Math.Max(1, value); }
        }
		[Description("Barras para el stop")]
        [Category("Parameters")]
        public int BarrasStop
        {
            get { return barrasStop; }
            set { barrasStop = Math.Max(0, value); }
        }
        #endregion
    }
}
